; ----------------- assembly instructions ---------------------------- 
;
; this is a subroutine library only
; it must be included in an executable source file
;
;
;*** I/O Locations *******************************
; define the i/o address of the UART

UART_BASE       =   $C008             
UART_STATUS     =   UART_BASE       
UART_DATA       =   UART_BASE +1     

;***********************************************************************
; UART I/O Support Routines
;
; input chr from ACIA1 (waiting)
;

UART_Input
               lda   UART_STATUS        ; Serial port status             
               and   #$40               ; is recvr full
               beq   UART_Input        ; no char to get
               Lda   UART_DATA          ; get chr
               RTS                      ;
;
; non-waiting get character routine 
;

UART_Scan     clc
               lda   UART_STATUS        ; Serial port status
               and   #$40               ; mask rcvr full bit
               beq   UART_scan2
               Lda   UART_DATA          ; get chr
               sec
UART_scan2    rts
;
; output to OutPut Port
;

UART_Output   PHA                      ; save registers
UART_Out1     lda   UART_STATUS        ; serial port status
               and   #$02               ; is tx buffer empty
               bNE   UART_Out1         ; no
               PLA                      ; get chr
               sta   UART_DATA          ; put character to Port
               RTS                      ; done
;
;end of file
